﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;

namespace RibbonWithMaskedEditTool
{
    class MyCreation:IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is EditorToolBaseUIElement)
            {
                UIElement img = GetDescendant("EditorToolImageUIElement", parent);// parent.ChildElements[0];
                TextUIElement text = GetDescendant("TextUIElement", parent) as TextUIElement;

                if (img != null && text != null)
                {
                    ImageAndTextUIElementEx rep = new ImageAndTextUIElementEx(parent);
                    PropertyInfo im = img.GetType().GetProperty("Image"); 
                    rep.Image = (Image)im.GetValue(img, null);
                    rep.Text = text.Text;
                    rep.Rect = new Rectangle(new Point(parent.Rect.X + 2, parent.Rect.Y + 1), new Size(text.Rect.Width, text.Rect .Height ));
                    rep.TextVAlign = VAlign.Middle;
                    parent.ChildElements.Add(rep);
                    parent.ChildElements.Remove(img);
                    parent.ChildElements.Remove(text);

                }

            }
          
        }

        private UIElement GetDescendant(string typeName, UIElement el )
        {
            if (el == null)
                return null;
            foreach (UIElement e in el.ChildElements)
            {
                if (e.GetType().Name == typeName)
                    return e;
            }

            foreach (UIElement e in el.ChildElements)
                return GetDescendant(typeName, e);

            return null;
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false; 
        }

        #endregion
    }
}
